commit 0212bcfc31a938d4b2f247dc42f75b1d523bb1ef
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Wed Sep 29 20:11:53 2021

    Fortran: fix error recovery for invalid constructor
    
    gcc/fortran/ChangeLog:
    
            PR fortran/102520
            * array.c (expand_constructor): Do not dereference NULL pointer.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/102520
            * gfortran.dg/pr102520.f90: New test.
    
    (cherry picked from commit 5e2adfeed21ee584a82cdcdfa7eed41202eb67cd)

diff --git a/gcc/fortran/array.c b/gcc/fortran/array.c
index b858bada18a..a4d1cb4c72d 100644
--- a/gcc/fortran/array.c
+++ b/gcc/fortran/array.c
@@ -1798,6 +1798,9 @@ expand_constructor (gfc_constructor_base base)
 
       e = c->expr;
 
+      if (e == NULL)
+	return false;
+
       if (empty_constructor)
 	empty_ts = e->ts;
 
diff --git a/gcc/testsuite/gfortran.dg/pr102520.f90 b/gcc/testsuite/gfortran.dg/pr102520.f90
new file mode 100644
index 00000000000..1c98c185c17
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr102520.f90
@@ -0,0 +1,12 @@
+! { dg-do compile }
+! PR fortran/102520 - ICE in expand_constructor, at fortran/array.c:1802
+
+program p
+  type t
+  end type
+  type(t), parameter :: a(4)   = shape(1)         ! { dg-error "Incompatible" }
+  type(t), parameter :: b(2,2) = reshape(a,[2,2]) ! { dg-error "Incompatible" }
+  type(t), parameter :: c(2,2) = transpose(b)     ! { dg-error "Unclassifiable" }
+end
+
+! { dg-error "Different shape for array assignment" " " { target *-*-* } 7 }

